/*
** Der umstlpbare Wrfel nach Paul Schatz
** (C) 1999,2004 Franz Zahaurek <http://www.fzk.at>
**
** Dieses Programm samt Dokumentation ist Freie Software und kann beliebig
** verwendet werden, soferne der obige Copyright-Vermerk nicht entfernt
** wird.
*/
/* $Id: wdisplists.c,v 1.3 2004/04/07 22:05:54 fzk Exp $ */

/* Erstellen der Display-Listen */

#ifndef OS_WIN32
  #include <config.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#ifndef OS_WIN32
#include <sys/time.h>
#endif
#include "wuerfel.h"

void axisTransform (void);
void createLines (void);
void createFill  (void);
void createLabels (void);
void createVirt (void);
void createAxis (void);
void createTouchline (void);
void createTimeform1 (void);
void createTimeform2 (void);
void zeigeMatrizen  (void);
void displayMatrix  (char *text, GLfloat *matrix16x16);

extern int    callFill, callLines, callVirt, callAxis, callTimeform, callTouchline;

#define OP(n,i) owgp->wgp.e[(n)-1].i
#define VON(n)  OP((n),x),OP((n),y),OP((n),z)
#define W       owgp->wgp.w
#define W2      owgp->wgp.w2
#define NACH(n) VON(n)

#define OPL(n,i) owgpl->wgp.e[(n)-1].i
#define VONL(n) OPL((n),x),OPL((n),y),OPL((n),z)
#define NACHL(n) VONL(n)

void
WglCreateDisplayLists () {
    int listId;
    WG *aktupos;
    static int e = 1; /* ecke */
    static int z = 1;
    RPUNKT zwi, prevzwi;

/*     fprintf (stderr, "Neue DisplayLists options.oloid=%s, options.kuboid=%s\n", */
/* 	     options.oloid?"true":"false", options.kuboid?"true":"false"); */

    aktupos = owgp;
    /*
    ** Die Gitterdarstellung des Wuerfelguertels
    */
    listIdLines = listIdLinesStart = listId = 1; /* listIdLines */
    for (owgp = wg; owgp; owgp = owgp->nextwgp) {
        glNewList (listId, GL_COMPILE);

	/* Beginn Achsentransformation fuer Liniendarstellung des Wuerfelguertels */
	glPushMatrix();

	axisTransform();

	createLines();
	createLabels();

	glPopMatrix();

	glEndList ();
        anzpos = listId;   /* anzpos gilt fuer alle Objekt-Listen */
        listId++;
    }

/*     fprintf (stderr, "Anzahl der Positionen in listIdLines =%d\n", */
/* 	     listId - listIdLines); */

    /*
    ** Die flaechigwe Darstellung des Wuerfelguertels
    */
    listIdFill = listIdFillStart = listId; /*  listIdFill */
    for (owgp = wg; owgp; owgp = owgp->nextwgp) {
        glNewList (listId, GL_COMPILE);

	/* Beginn Achsentransformation fuer Flchendarstellung des Wuerfelguertels */
	glPushMatrix();

	axisTransform();

	createFill();
	createLabels();

	glPopMatrix();

	glEndList ();
	listId++;
    }

/*     fprintf (stderr, "Anzahl der Positionen in listIdFill =%d\n", */
/* 	     listId - listIdFill); */

    /*
    ** Die Beruehrungslinien Timeform - Wuerfelguertel
    */
    listIdTouch = listIdTouchStart = listId; /*  listIdTouch */
    for (owgp = wg; owgp; owgp = owgp->nextwgp) {
        glNewList (listId, GL_COMPILE);

	glPushMatrix();

        axisTransform();
	createTouchline();

	glPopMatrix();

	glEndList ();
	listId++;
    }

/*     fprintf (stderr, "Anzahl der Positionen in listIdTouch =%d\n", */
/* 	     listId - listIdTouch); */

    /*
    ** Die 6 gedachten/virtuellen Verbindungen der Scharniere des Wuerfelguertels
    ** mit Evolutions- und Involutionspunkt
    */
    listIdVirt = listIdVirtStart = listId; /* listIdVirt */
    for (owgp = wg; owgp; owgp = owgp->nextwgp) {
        glNewList (listId, GL_COMPILE);

	glPushMatrix();

	axisTransform();
	createVirt();

	glPopMatrix();

        glEndList ();
        listId++;
    }

/*     fprintf (stderr, "Anzahl der Positionen in listIdVirt =%d\n", */
/* 	     listId - listIdVirt); */

    /*
    ** Die Koordinatenachsen
    */
    listIdAxis = listIdAxisStart = listId; /* listIdAxis */
    for (owgp = wg; owgp; owgp = owgp->nextwgp) {
        glNewList (listId, GL_COMPILE);

	glPushMatrix();
	axisTransform();

	createAxis();

	glPopMatrix();

        glEndList ();
        listId++;
    }

/*     fprintf (stderr, "Anzahl der Positionen in listIdAxis =%d\n", */
/* 	     listId - listIdAxis ); */

    /*
    ** Die Zeitformen Oloid und Kuboid Teil A) die Erzeugende
    */
    listIdTime1 = listIdTime1Start = listId; /*  listIdTime1 */
    glNewList (listId, GL_COMPILE);

    createTimeform1();

    glEndList ();
    listId++;

/*     fprintf (stderr, "Anzahl der Positionen in listIdTime1 =%d\n", */
/* 	     listId - listIdTime1); */

    /*
    ** Die Zeitformen Oloid und Kuboid Teil B) die Endpunkte der Erzeugenden
    */
    listIdTime2 = listIdTime2Start = listId; /*  listIdTime2 */
    glNewList (listId, GL_COMPILE);

    createTimeform2();

    glEndList ();
    listId++;

/*     fprintf (stderr, "Anzahl der Positionen in listIdTime2 =%d\n", */
/* 	     listId - listIdTime2); */


    owgp = wg; // aktupos;
}

void axisTransform () {
	/*
	** Achsentransformation so durchfuehren, dass das Oloid/Kuboid
	** erkennbar wird.
	*/
	if (options.axistrans == 2) {
	  glRotatef (GWINKEL(owgp->wgp.w2), 1., 0., 0.);
	  glRotatef (GWINKEL(owgp->wgp.w),  0., 1., 0.);
	}
	if (options.axistrans == 1) {
	  glRotatef (GWINKEL(owgp->wgp.w),  0., 1., 0.);
	}
/* 	if (options.mode == 4) { */
/* 	  fprintf (stderr, "."); */
/* 	  glTranslatef (owgp->wgp.e[2-1].x < 0. ? -owgp->wgp.e[2-1].x : 0., 0., 0.); */
/* 	} */

//	zeigeMatrizen ();
}

void createLines () {
        glColor3f (1.0, 1.0, 1.0);
        glClearColor (0.7, 0.7, 0.0, 0.0);
        glLineWidth (1.0);
        glEnable (GL_LINE_SMOOTH);

        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(3));
          glVertex3f (VON(1));
          glVertex3f (VON(2));
          glVertex3f (VON(4));
          glVertex3f (VON(1));
        glEnd ();
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(7));
          glVertex3f (VON(8));
          glVertex3f (VON(3));
          glVertex3f (VON(4));
          glVertex3f (VON(8));
        glEnd ();
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(5));
          glVertex3f (VON(6));
          glVertex3f (VON(7));
          glVertex3f (VON(8));
          glVertex3f (VON(6));
        glEnd ();
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(13));
          glVertex3f (VON(11));
          glVertex3f (VON(12));
          glVertex3f (VON(14));
          glVertex3f (VON(11));
        glEnd ();
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(17));
          glVertex3f (VON(18));
          glVertex3f (VON(13));
          glVertex3f (VON(14));
          glVertex3f (VON(18));
        glEnd ();
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(15));
          glVertex3f (VON(16));
          glVertex3f (VON(17));
          glVertex3f (VON(18));
          glVertex3f (VON(16));
        glEnd ();
}

void createFill () {
        glClearColor (0.7, 0.7, 0.0, 0.0);
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(3)); glColor3f (VON(3));
          glVertex3f (VON(1)); glColor3f (VON(1));
          glVertex3f (VON(2)); glColor3f (VON(2));
          glVertex3f (VON(4)); glColor3f (VON(4));
          glVertex3f (VON(1)); glColor3f (VON(1));
        glEnd ();
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(7)); glColor3f (VON(7));
          glVertex3f (VON(8)); glColor3f (VON(8));
          glVertex3f (VON(3)); glColor3f (VON(3));
          glVertex3f (VON(4)); glColor3f (VON(4));
          glVertex3f (VON(8)); glColor3f (VON(8));
        glEnd ();
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(5)); glColor3f (VON(5));
          glVertex3f (VON(6)); glColor3f (VON(6));
          glVertex3f (VON(7)); glColor3f (VON(7));
          glVertex3f (VON(8)); glColor3f (VON(8));
          glVertex3f (VON(6)); glColor3f (VON(6));
        glEnd ();
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(13)); glColor3f (VON(3));
          glVertex3f (VON(11)); glColor3f (VON(1));
          glVertex3f (VON(12)); glColor3f (VON(2));
          glVertex3f (VON(14)); glColor3f (VON(4));
          glVertex3f (VON(11)); glColor3f (VON(1));
        glEnd ();
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(17)); glColor3f (VON(7));
          glVertex3f (VON(18)); glColor3f (VON(8));
          glVertex3f (VON(13)); glColor3f (VON(3));
          glVertex3f (VON(14)); glColor3f (VON(4));
          glVertex3f (VON(18)); glColor3f (VON(8));
        glEnd ();
        glBegin (GL_TRIANGLE_FAN);
          glVertex3f (VON(15)); glColor3f (VON(5));
          glVertex3f (VON(16)); glColor3f (VON(6));
          glVertex3f (VON(17)); glColor3f (VON(7));
          glVertex3f (VON(18)); glColor3f (VON(8));
          glVertex3f (VON(16)); glColor3f (VON(6));
        glEnd ();
}


/* Labels in x-Richtung etwas nach rechts verschoben */
#define VONDIST(n)  OP((n),x)+.05,OP((n),y),OP((n),z)

void createLabels () {
  GLfloat params[4];

  glGetFloatv(GL_CURRENT_COLOR, params); 
  glColor3f (0., 0., 0.); /* Labels immer in Schwarz */
        if (options.labels) {
	  glRasterPos3f (VONDIST(1)); WglDrawString ("1");
	  glRasterPos3f (VONDIST(2)); WglDrawString ("2");
	  glRasterPos3f (VONDIST(3)); WglDrawString ("3");
	  glRasterPos3f (VONDIST(4)); WglDrawString ("4");

	  glRasterPos3f (VONDIST(5)); WglDrawString ("5");
	  glRasterPos3f (VONDIST(6)); WglDrawString ("6");
	  glRasterPos3f (VONDIST(7)); WglDrawString ("7");
	  glRasterPos3f (VONDIST(8)); WglDrawString ("8");

	  glRasterPos3f (VONDIST(17)); WglDrawString ("17");
        }
  glColor4fv (params);
}

void createTouchline () {
  GLfloat params[4];

	/*
	** Beruehrungslinie zwischen Oloid/Kuboid und Wrfelgrtel
	** nur, wenn eines der beiden Objekte dargestellt wird
	*/
	glLineWidth (5.0);
	//        glEnable (GL_LINE_SMOOTH);
	glColor3f (1.,1.,1.);
        glClearColor (0.7, 0.7, 0.0, 0.0);
	glBegin (GL_LINES);

	if (options.oloid) {
	  glVertex3f (VON(3)); 
	  glVertex3f (VON(17));
	  if (options.labels) {
	    glGetFloatv(GL_CURRENT_COLOR, params); 
	    glColor3f (0., 0., 0.); /* Labels immer in Schwarz */

	    glRasterPos3f (VONDIST(3)); WglDrawString ("3");
	    glRasterPos3f (VONDIST(17)); WglDrawString ("17");

	    glColor4fv (params);
	  }
	}
	if (options.kuboid) {
	  glVertex3f (VON(3));
	  glVertex3f (VON(7));
	  glVertex3f (VON(7));
	  glVertex3f (VON(5));
	  if (options.labels) {
	    glGetFloatv(GL_CURRENT_COLOR, params); 
	    glColor3f (0., 0., 0.); /* Labels immer in Schwarz */

	    glRasterPos3f (VONDIST(3)); WglDrawString ("3");
	    glRasterPos3f (VONDIST(7)); WglDrawString ("7");
	    glRasterPos3f (VONDIST(5)); WglDrawString ("5");

	    glColor4fv (params);
	  }
	}
	glEnd ();

	/*
	** Radien zu den Enden der Berhrungslinie(n)
	** vielleicht doch nicht so anschaulich ?
	*/
	glLineWidth (1.0);
	glColor3f (.6,.6,.1);
        glClearColor (0.7, 0.7, 0.0, 0.0);
	glBegin (GL_LINES);

	if (options.oloid) {
	  glVertex3f (VON(1)); 
	  glVertex3f (VON(3));
	  glVertex3f (VON(17)); 
	  glVertex3f (VON(13));
	  glVertex3f (VON(13));
	  glVertex3f (VON(1));
	}
	if (options.kuboid) {
	  glVertex3f (VON(1)); 
	  glVertex3f (VON(3));
	  glVertex3f (VON(5));
	  glVertex3f (VON(1)); 
	}

	glEnd ();
	glLineWidth (1.0);
}

/*
** Makros fuer die manuelle Achsentransformation x/y/z
** und zwar jeweils die aktuelle und die vorherige Position (previous)
*/
#define OPP(n,i) prevwgp->wgp.e[(n)-1].i
#define PREVVON(n) OPP((n),x),OPP((n),y),OPP((n),z)
#define WP       (prevwgp->wgp.w)
#define W2P      (prevwgp->wgp.w2)

#define TRAN1X(l) \
        zwi1.x = OP(l,x); \
        zwi1.y = OP(l,y) *  cos(M_PI/2.-W2) + OP(l,z) *  sin(M_PI/2.-W2); \
        zwi1.z = OP(l,y) * -sin(M_PI/2.-W2) + OP(l,z) *  cos(M_PI/2.-W2);
#define TRAN2Y(l) \
        zwi2.x = zwi1.x *  cos(M_PI/2.-W) + zwi1.z * -sin(M_PI/2.-W); \
        zwi2.y = zwi1.y; \
        zwi2.z = zwi1.x *  sin(M_PI/2.-W) + zwi1.z *  cos(M_PI/2.-W);

#define TRAN1XP(l) \
        zwi1.x = OPP(l,x); \
        zwi1.y = OPP(l,y) *  cos(M_PI/2.-W2P) + OPP(l,z) *  sin(M_PI/2.-W2P); \
        zwi1.z = OPP(l,y) * -sin(M_PI/2.-W2P) + OPP(l,z) *  cos(M_PI/2.-W2P);
#define TRAN2YP(l) \
        zwi2.x = zwi1.x *  cos(M_PI/2.-WP) + zwi1.z * -sin(M_PI/2.-WP); \
        zwi2.y = zwi1.y; \
        zwi2.z = zwi1.x *  sin(M_PI/2.-WP) + zwi1.z *  cos(M_PI/2.-WP);


/* #define MAXFEEDBACK 5000 */
void createTimeform1 () {
	WG *owgp;
	int pos;
/* 	GLfloat windowcoord[MAXFEEDBACK]; */
/* 	GLint ctwindowcoord; */
/* 	int feedbackposition; */

	/*
	** window cordinates der Punkte mit glFeedbackBuffer ermitteln
	** waehrend dieses Schritts wird nicht gezeichnet. Danach mssen
	** jeweils 2 aufeinanderfolgende Punkte mit einer Linie verbunden
	** werden.
	*/
/* 	fprintf (stderr, "fill up Feedback-Buffer\n"); */
/* 	glFeedbackBuffer (MAXFEEDBACK, GL_3D_COLOR, windowcoord); */
/* 	WglTestGlError ("glFeedbackBuffer"); */
/* 	(void) glRenderMode (GL_FEEDBACK); */
/* 	WglTestGlError ("glRenderMode"); */

	/*
	** Oloid / Kuboid
	*/
/* 	feedbackposition = 0; */
/* 	for (owgp = wg; owgp; owgp = owgp->nextwgp) { */

/*           glPushMatrix(); */

/* 	  if (options.oloid) { */
/* 	    glRotatef (GWINKEL(owgp->wgp.w2), 1., 0., 0.); */
/* 	    glRotatef (GWINKEL(owgp->wgp.w),  0., 1., 0.); */
/* 	  } */
/* 	  if (options.kuboid) { */
/* 	    glRotatef (GWINKEL(owgp->wgp.w),  0., 1., 0.); */
/* 	  } */

/* 	  glBegin (GL_POINTS); */

/* 	  fprintf (stderr, "Mark feedback-position %f\n", (GLfloat)(feedbackposition+1)); */
/* 	  glPassThrough ((GLfloat)(++feedbackposition)); */
/* 	  WglTestGlError ("glPassThrough"); */

/* 	  if (options.oloid) { */
/*             glVertex3f (VON(3)); */
/*             glVertex3f (VON(17)); */
/* 	  } */
/* 	  if (options.kuboid) { */
/*             glVertex3f (VON(3)); */
/*             glVertex3f (VON(7)); */
/*             glVertex3f (VON(7)); */
/*             glVertex3f (VON(5)); */
/* 	  } */

/* 	  glEnd (); */
/*           glPopMatrix(); */
/* 	} */
/* 	ctwindowcoord = glRenderMode (GL_RENDER); */
/* 	WglTestGlError ("glRenderMode"); */
/* 	fprintf (stderr, "%d Punkte im Feedback-Buffer\n", ctwindowcoord); */


	/*
	** Oloid / Kuboid zuerst Linien in gedeckter Farbe ...
	*/
	for (owgp = wg, pos=0; owgp; owgp = owgp->nextwgp, pos++) {
	  if (pos % 2 != 0) {
	    continue;
	  }

          glPushMatrix();

	  if (options.axistrans == 2) {
	    glRotatef (GWINKEL(owgp->wgp.w2), 1., 0., 0.);
	    glRotatef (GWINKEL(owgp->wgp.w),  0., 1., 0.);
	  }
	  if (options.axistrans == 1) {
	    glRotatef (GWINKEL(owgp->wgp.w),  0., 1., 0.);
	  }

	  glColor3f (0.4,0.4,0.2);
	  glClearColor (0.7, 0.7, 0.0, 0.0);
	  glLineWidth (1.);
	  glBegin (GL_LINES);

	  if (options.oloid) {
            glVertex3f (VON(3)); 
            glVertex3f (VON(17));
	  }
	  if (options.kuboid) {
            glVertex3f (VON(3));
            glVertex3f (VON(7));
            glVertex3f (VON(7));
            glVertex3f (VON(5));
	  }
	  glEnd ();

          glPopMatrix();
	}
}

void createTimeform2 () {
	WG *owgp;

	/*
	** Oloid/Kuboid die Endpunkte der Linien hell
	*/
	for (owgp = wg; owgp; owgp = owgp->nextwgp) {

          glPushMatrix();

	  if (options.axistrans == 2) {
	    glRotatef (GWINKEL(owgp->wgp.w2), 1., 0., 0.);
	    glRotatef (GWINKEL(owgp->wgp.w),  0., 1., 0.);
	  }
	  if (options.axistrans == 1) {
	    glRotatef (GWINKEL(owgp->wgp.w),  0., 1., 0.);
	  }

	  glColor3f (1.,1.,1.);
	  glClearColor (0.7, 0.7, 0.2, 0.0);
	  glPointSize (3.);
	  glBegin (GL_POINTS);

	  if (options.oloid) {
            glVertex3f (VON(3)); 
            glVertex3f (VON(17));
	  }
	  if (options.kuboid) {
            glVertex3f (VON(3));
            glVertex3f (VON(7));
            glVertex3f (VON(5));
	  }

	  glEnd ();

          glPopMatrix();
	}
}

void createVirt () {
        glColor3f (1.0, 1.0, 1.0);
        glClearColor (0.7, 0.7, 0.0, 0.0);
        glLineWidth (1.0);

	glBegin (GL_LINES);
	  glVertex3f (VON(4));  glVertex3f (NACH(9));
	  glVertex3f (VON(6));  glVertex3f (NACH(9));
	  glVertex3f (VON(14)); glVertex3f (NACH(9));

	  glVertex3f (VON(2));  glVertex3f (NACH(10));
	  glVertex3f (VON(8));  glVertex3f (NACH(10));
	  glVertex3f (VON(18)); glVertex3f (NACH(10));
	glEnd ();
}

void createAxis () {
  GLfloat params[4];

        glColor3f (1.0, 1.0, 1.0);
        glClearColor (0.7, 0.7, 0.0, 0.0);
        glLineWidth (1.0);

        glBegin (GL_LINES);
          glVertex3f (VON(1)); glVertex3f (NACH(19));
          glVertex3f (VON(1)); glVertex3f (NACH(20));
          glVertex3f (VON(1)); glVertex3f (NACH(21));
        glEnd ();

  glGetFloatv(GL_CURRENT_COLOR, params); 
  glColor3f (0., 0., 0.); /* Labels immer in Schwarz */
        glRasterPos3f (VON(19));
        WglDrawString ("X");
        glRasterPos3f (VON(20));
        WglDrawString ("Y");
        glRasterPos3f (VON(21));
        WglDrawString ("Z");
  glColor4fv (params);
}


// ==   #define TRANZ(l) \
// ==           zwi.x = OPP(l,x) *  cos(M_PI/2.-WL) + OPP(l,y) * -sin(M_PI/2.-WL); \
// ==           zwi.y = OPP(l,y) * -sin(M_PI/2.-WL) + OPP(l,y) *  cos(M_PI/2.-WL); \
// ==           zwi.z = OPP(l,z);

// ==	/*
// ==	** Oloid / Kuboid
// ==	*/
// ==	if (options.oloid || options.kuboid) {
// ==	  for (owgpl = wg; owgpl; owgpl = owgpl->nextwgp) {
// ==	    WG *prevwgp;
// ==
// ==	    prevwgp = (owgp == wg) ? last : owgp->prevwgp;
// ==            glPushMatrix();
// ==
// ==	    if (options.oloid) {
// ==	      glRotatef (GWINKEL(owgpl->wgp.w2), 1., 0., 0.);
// ==	      glRotatef (GWINKEL(owgpl->wgp.w),  0., 1., 0.);
// ==	    }
// ==	    if (options.kuboid) {
// ==	      glRotatef (GWINKEL(owgpl->wgp.w),  0., 1., 0.);
// ==	    }
// ==	    glBegin (GL_LINES);
// ==	    if (options.oloid) {
// ==/* 	      RPUNKT zwi1, zwi2; */
// ==/* 	      TRAN1X(3); */
// ==/* 	      TRAN2Y(3); */
// ==/*               glVertex3f (zwi2.x,zwi2.y,zwi2.z); glColor3f (zwi2.x,zwi2.y,zwi2.z); */
// ==/*               glVertex3f (VONL(3)); glColor3f (VONL(3)); */
// ==              glVertex3f (VONL(3)); glColor3f (VONL(3));
// ==              glVertex3f (VONL(17)); glColor3f (VONL(17));
// ==/*               glVertex3f (VONL(17)); glColor3f (VONL(17)); */
// ==/*               glVertex3f (PREVVON(17)); glColor3f (PREVVON(17)); */
// ==	    }
// ==	    else if (options.kuboid) {
// ==              glVertex3f (VONL(3)); glColor3f (VONL(3));
// ==              glVertex3f (VONL(7)); glColor3f (VONL(7));
// ==              glVertex3f (VONL(7)); glColor3f (VONL(7));
// ==              glVertex3f (VONL(5)); glColor3f (VONL(5));
// ==	    }
// ==	    glEnd ();
// ==            glPopMatrix();
// ==	  }
// ==	}


#define ZVON zwi.x,zwi.y,zwi.z
#define ZPREVVON prevzwi.x,prevzwi.y,prevzwi.z

#define QUAD(a,b) \
        glVertex3f (VON(a));  glColor3f (VON(a)); \
	glVertex3f (VON(b));  glColor3f (VON(b)); \
	glVertex3f (PREVVON(b)); glColor3f (PREVVON(b)); \
	glVertex3f (PREVVON(a)); glColor3f (PREVVON(a));

	/* Polkuboid mit explizit berechneter Achsentransformation */
/*           glBegin (GL_LINES); */
/* 	    TRANY(3) */
/* 	    glVertex3f (ZVON); glColor3f (ZVON); */
/* 	    PREVTRANY(3) */
/* 	    glVertex3f (ZPREVVON); glColor3f (ZPREVVON); */

/* 	    TRANY(3) */
/* 	    glVertex3f (ZVON); glColor3f (ZVON); */
/* 	    TRANY(7) */
/* 	    glVertex3f (ZVON); glColor3f (ZVON); */

/* 	    TRANY(7) */
/* 	    glVertex3f (ZVON); glColor3f (ZVON); */
/* 	    PREVTRANY(7); */
/* 	    glVertex3f (ZPREVVON); glColor3f (ZPREVVON); */

/* 	    TRANY(7) */
/* 	    glVertex3f (ZVON); glColor3f (ZVON); */
/* 	    TRANY(5) */
/* 	    glVertex3f (ZVON); glColor3f (ZVON); */

/* 	    TRANY(5) */
/* 	    glVertex3f (ZVON); glColor3f (ZVON); */
/* 	    PREVTRANY(5); */
/* 	    glVertex3f (ZPREVVON); glColor3f (ZPREVVON); */
/*           glEnd (); */


/*
** diplayMatrix gibt die 16 hintereinander liegenden floats in einer column-major
** Reihenfolge aus. m ist ein beliebiger erklaerender Text.
*/
void
displayMatrix (char *m, GLfloat *f) {
  int i;

  fprintf (stderr, "%s\n", m);
  for (i=0; i<16; i+=4) {
    fprintf (stderr, "  %5.2f %5.2f %5.2f %5.2f\n", f[i], f[i+4], f[i+8], f[i+12]);
  }

}

void
zeigeMatrizen () {
    GLfloat mvMatrix[16];
    GLfloat pvMatrix[16];
    char text[100];

/*     glGetFloatv (GL_MODELVIEW_MATRIX, &mvMatrix[0]); */
/*     displayMatrix ("mvMatrix start", &mvMatrix[0]); */
/*     glGetFloatv (GL_PROJECTION_MATRIX, &pvMatrix[0]); */
/*     displayMatrix ("pvMatrix start", &pvMatrix[0]); */

    sprintf (text, "mvMatrix in die x/y Achse bei w=%6.2f, w2=%6.2f",
	     GWINKEL(owgp->wgp.w), GWINKEL(owgp->wgp.w2));
    glGetFloatv (GL_MODELVIEW_MATRIX, &mvMatrix[0]);
    displayMatrix (text, &mvMatrix[0]);
    sprintf (text, "pvMatrix in die x/y Achse bei w=%6.2f, w2=%6.2f",
	     GWINKEL(owgp->wgp.w), GWINKEL(owgp->wgp.w2));
    glGetFloatv (GL_PROJECTION_MATRIX, &pvMatrix[0]);
    displayMatrix (text, &pvMatrix[0]);
}



/* 	  RPUNKT zwivon, zwinach, zwi1, zwi2; */
/* 	  WG *prevwgp; */

/* 	  prevwgp = (owgp == wg) ? last : owgp->prevwgp; */
	  
/* ... */
	  /*
	  ** Verbindung zum gleichnamigen Punkt der vorigen Position
	  */
/* 	  glBegin (GL_LINES); */
/* 	    prevwgp = (owgp == wg) ? last : owgp->prevwgp; */
/* 	    TRAN1XP(3); */
/* 	    TRAN2YP(3); */
/* 	    zwivon.x = zwi2.x; zwivon.y = zwi2.y; zwivon.z = zwi2.z; */
/* 	    glVertex3f (zwivon.x,zwivon.y,zwivon.z); glColor3f (0.6,0.6,0.2); */

/* 	    TRAN1X(3); */
/* 	    TRAN2Y(3); */
/* 	    zwinach.x = zwi2.x; zwinach.y = zwi2.y; zwinach.z = zwi2.z; */
/* 	    glVertex3f (zwinach.x,zwinach.y,zwinach.z); glColor3f (0.6,0.6,0.2); */
/* 	  glEnd (); */
